from abc import ABC, abstractmethod

class ABD(ABC):
	"""
	#### Abstract Base Dataclass

	This will only work on dataclasses
	"""
	def __post_init__(self, *args, **kwargs):
		if ABD in self.__class__.__bases__ or ABD == self.__class__:
			msg = f"Cannot instantiate an Abstract Base Dataclass: {self.__class__.__name__}"
			raise TypeError(msg)

# TODO: Make a subclass of EnumMeta to do this
class ABE:
	"""
	#### Abstract Base Enum
	
	This is for classes that will have an Enum subclass them.

	Do not implement a __init__ method for the class directly inheriting from ABE
	"""
	def __init__(self, *args, **kwargs):
		if ABE in self.__class__.__bases__ or ABE == self:
			msg = f"Cannot instantiate an Abstract Base Enum: {self.__class__.__name__}"
			raise TypeError(msg)
